
var SPORTS = [
  {code: "MBA", description: "Baseball", nc: false},
  {code: "WFH", description: "Field Hockey", nc: false},
  {code: "MFB", description: "Football", nc: false},
  {code: "MBB", description: "Men's Basketball", nc: false},
  {code: "MCC", description: "Men's Cross Country", nc: false},
  {code: "MGO", description: "Men's Golf", nc: false},
  {code: "MGY", description: "Men's Gymnastics", nc: true},
  {code: "MIH", description: "Men's Ice Hockey", nc: false},
  {code: "MLA", description: "Men's Lacrosse", nc: false},
  {code: "MSO", description: "Men's Soccer", nc: false},
  {code: "MSW", description: "Men's Swimming", nc: false},
  {code: "MTE", description: "Men's Tennis", nc: false},
  {code: "MTI", description: "Men's Track, Indoor", nc: false},
  {code: "MTO", description: "Men's Track, Outdoor", nc: false},
  {code: "MVB", description: "Men's Volleyball", nc: true},
  {code: "MWP", description: "Men's Water Polo", nc: true},
  {code: "MWR", description: "Men's Wrestling", nc: false},
  {code: "XFE", description: "Fencing", nc: true},
  {code: "XRI", description: "Rifle", nc: true},
  {code: "XSK", description: "Skiing", nc: true},
  //{code: "NI2", description: "NIT Postseason", nc: false},
  //{code: "NIT", description: "NIT Preseason", nc: false},
  {code: "WBB", description: "Women's Basketball", nc: false},
  {code: "WBW", description: "Bowling", nc: true},
  {code: "WCC", description: "Women's Cross Country", nc: false},
  {code: "WGO", description: "Women's Golf", nc: false},
  {code: "WGY", description: "Women's Gymnastics", nc: true},
  {code: "WIH", description: "Women's Ice Hockey", nc: true},
  {code: "WLA", description: "Women's Lacrosse", nc: false},
  {code: "WCR", description: "Women's Rowing", nc: false},
  {code: "WSO", description: "Women's Soccer", nc: false},
  {code: "WSB", description: "Women's Softball", nc: false},
  {code: "WSW", description: "Women's Swimming", nc: false},
  {code: "WTE", description: "Women's Tennis", nc: false},
  {code: "WTI", description: "Women's Track, Indoor", nc: false},
  {code: "WTO", description: "Women's Track, Outdoor", nc: false},
  {code: "WVB", description: "Women's Volleyball", nc: false},
  {code: "WWP", description: "Women's Water Polo", nc: true}
];

var DIVS                = ["NC", "I", "II", "III"];
var divisions           = [];
var sports              = [];
var all_championships   = false;
var deviceToken         = null;
var deviceType          = null;
var headings            = [];
var manualSportTemplate = null;
var manualLinkTemplate  = null;
var headingTemplate     = null;
var articleTemplate     = null;
var sportTemplate       = null;

function setDeviceToken(token) {
  deviceToken = token;
  saveValue('deviceToken');
}

function setDeviceType(type) {
  deviceType = type;
  saveValue('deviceType');
}

function getDeviceToken() {
  if (!deviceToken) {
    deviceToken = localStorage.getItem('deviceToken')
  }
  return deviceToken;
}

function getDeviceType() {
  if (!deviceType) {
    deviceType  = localStorage.getItem('deviceType')
  }
  return deviceType;
}

function setValue(variableName, value) {
  eval(variableName + ".push('" + value + "')");
  saveValue(variableName);
}

function removeValue(variableName, value) {
  eval(variableName + '.splice(' + variableName + ".indexOf('" + value + "'),1)");
  saveValue(variableName);
}

function saveValue(variableName) {
  var val = eval(variableName + ".toString()")
  localStorage.setItem(variableName, val);
}

function getSport(sportCode) {
  for (var i=0; i < SPORTS.length; i++) {
    if (SPORTS[i]['code'] === sportCode) {
      return SPORTS[i];
    }
  }
}

var manualLinks = [];

function gotoManuals() {
  $('#manuals_section').empty();
  if (all_championships) {
    loadLinks([1,2,3],['ALL'])
  } else {
    var divs = divisions;
    if (divisions.indexOf('0') > -1 || divisions.length == 0) {
      divs = [1,2,3];
    }
    loadLinks(divs,sports);
  }
}

function displayManualLinks() {
  for (var i=0; i < manualLinks.length; i++) {
    if (manualLinks[i].championship_articles.length > 0) {
      $('#manuals_section').append(manualSportTemplate(manualLinks[i]));
      for (var j=0; j < manualLinks[i].championship_articles.length; j++) {
        $('#' + manualLinks[i].division + manualLinks[i].sport_code).append(manualLinkTemplate(manualLinks[i].championship_articles[j]));
      }
    }
  }
  $("#manuals_section ul").on("singletap", "li", function() {
    //alert($(this).data('href'));
    var ref = window.open($(this).data('href'), "_blank");
  });

}

function loadLinks(divisions, sports) {
  $.ajax({ type: 'get', data: {'sports' : all_championships ? 'ALL' : sports.toString(), 'divisions' : divisions.toString()}, dataType: 'json', url: 'http://championships.ncaa.org/articles', success: function(data) {manualLinks = data; displayManualLinks(); }});
}

function updateServer() {
  var token = getDeviceToken();
  if (!token) {
    return;
  }

  var sportString = (all_championships ? 'ALL' : sports.toString());

  jQuery.ajax({ url: "http://championships.ncaa.org/devices/save?device[type]=" + getDeviceType() + "&device[token]=" + token + "&device[sports]=" + sportString + "&device[divisions]=" + divisions.toString(), type: 'POST' });
}

function buildSport(division, sportObj) {
  var sport = {};
  sport.code        = sportObj['code'];
  sport.description = sportObj['description'];
  if (division > 0) {
    sport.full_description = "Division " + DIVS[division] + " " + sportObj['description'];
  } else {
    sport.full_description = sportObj['description'];
  }
  sport.division    = division;
  return sport;
}

function hasSelected(sportCode, division) {
  return all_championships || (sports.indexOf(sportCode) >= 0 && (divisions.indexOf("0") >= 0 || divisions.indexOf(division) >= 0));
}

function buildDivision(division) {
  for (var sportIndex = 0; sportIndex < SPORTS.length; sportIndex++) {
    if (((division > 0 && !SPORTS[sportIndex]['nc']) || (division == 0 && SPORTS[sportIndex]['nc'])) && (all_championships || sports.indexOf(SPORTS[sportIndex]['code']) >= 0)) {
      var sport = buildSport(division, SPORTS[sportIndex]);
      $('body').append(' <nav class="next" id="' + sport.code + '_nav"> <a class="button back">Back</a> <h1>' + sport.description + '</h1> </nav> <article id="' + sport.division + sport.code + '" class="next"> <section id="' + sport.division + sport.code + '_section"> </section> </article>');
      $('#list_' + division).append('<li id="' + division + '_' + sport.code + '" class="nav" data-goto="' + division + sport.code + '" data-function="gotoSport">' + sport.description + '</li>');
      //$('body').append(sportTemplate(sport));
      //$('#list_' + division).append(mainTemplate(sport));
    }
  }
}

function buildMainPage() {
  return;
  $('#main_section').empty();

  var divs = divisions;
  if (all_championships || divisions.indexOf('0') > -1 || divisions.length == 0) {
    divs = [1,2,3];
    //divs = [1];
  }

  for (var divIndex = 0; divIndex < divs.length; divIndex++) {
    $('#main_section').append('<h2>Division ' + divs[divIndex] + '</h2><ul class="list" id="list_' + divs[divIndex] + '"></ul>');
    buildDivision(parseInt(divs[divIndex]));
  }

  for (var sportIndex = 0; sportIndex < SPORTS.length; sportIndex++) {
    if (SPORTS[sportIndex]['nc'] && (all_championships || sports.indexOf(SPORTS[sportIndex]['code']) >= 0)) {
      $('#main_section').append('<h2>National Collegiate</h2><ul class="list" id="list_0"></ul>');
      buildDivision(0);
      break;
    }
  }

  $("#main").on("singletap", "li", function() {
    if ($(this).data("function")) {
      var func = window[$(this).data("function")];
      func(this);
    }
  });
}

function displayHeadings(division, sport) {
  //if ($('#' + division + sport).length > 0) {
    //return;
  //}
  //var sectionId = '#' + division + sport + '_section';
  var sectionId = '#sport_section';

  $(sectionId).empty();

  var groups = headings['headings'];

  for (var j=0; j < groups.length; j++) {
    var articles = groups[j];
    for (var i=0; i < articles.length; i++) {
      if (articles[i].championship_articles.length > 0) {
        $(sectionId).append(headingTemplate(articles[i]));
        for (var j=0; j < articles[i].championship_articles.length; j++) {
          $('#heading_' + articles[i].id).append(articleTemplate(articles[i].championship_articles[j]));
        }
      }
    }
  }

  $(sectionId + " ul").on("singletap", "li", function() {
    //alert($(this).data('href'));
    if (device.platform == 'android' || device.platform == 'Android') {
      var ref = window.open($(this).data('href'), "_system");
    } else {
      var ref = window.open($(this).data('href'), "_blank");
    }
  });

  if (headings['events'].length > 0) {
    $(sectionId).append('<h2>Key Dates</h2><ul id="events_' + division + sport + '" class="list"></ul');
    for (var i=0; i < headings['events'].length; i++) {
      $('#events_' + division + sport).append('<li><h3>' + headings['events'][i].summary + '</h3><h4>' + headings['events'][i].dates + '</h4></li>');
                                              //<h5>' + headings['events'][i].description + '</h5></li>');
    }
  }

  var notifications = headings['notifications'];

  if (notifications.length > 0) {
    $(sectionId).append('<h2>Notifications</h2><ul id="notifications_' + division + sport + '" class="list"></ul');
    for (var i=0; i < notifications.length; i++) {
      $('#notifications_' + division + sport).append('<li>' + notifications[i].message + '</li>');
    }
  }
}

function gotoSport(element) {
  $('#sport_section').empty();
  headings  = [];
  var parts = element.id.split('_');
  $('#sport_title').text(getSport(parts[1])['description']);
  //ProgressIndicator.showSimple(true);
  //$.UIPopup({empty: true});
  $('#sport_section').UIBusy({'color':'#000', 'size': '50px'});
  $('#sport_section').find('.busy').UICenter();
  $.ajax({ type: 'get', data: {'sport' : parts[1], 'division' : parts[0]}, dataType: 'json', url: 'http://championships.ncaa.org/articles.json', success: function(data) {headings = data; displayHeadings(parts[0], parts[1]);  /* ProgressIndicator.hide(); */ }, complete: function(data){$('#sport_section .busy').remove(); $('.popup').UIPopupClose();}});
  $.UIGoToArticle('#sport');
}

function updateMainPage() {
  if (all_championships) {
    $('#main_section h2').show();
    $('#main_section ul').show();
    $('#main_section li').show();
    return;
  }

  $('#main_section h2').hide();
  $('#main_section ul').hide();
  $('#main_section li').hide();

  var divs = divisions;

  //alert(divs);
  //alert(divs.length);

  if (all_championships || divisions.indexOf('0') > -1 || divisions.length == 0) {
    divs = [1,2,3];
  }

  //alert(divs);

  for (var divIndex = 0; divIndex < divs.length; divIndex++) {
    $('#main_section .d' + divs[divIndex]).show();
    for (var sportIndex = 0; sportIndex < sports.length; sportIndex++) {
      if (getSport(sports[sportIndex]).nc) {
        $('#main_section .d0').show();
        $('#0_' + sports[sportIndex]).show();
      } else {
        $('#' + divs[divIndex] + '_' + sports[sportIndex]).show();
      }
    }
  }
}

$(function() {
  $("#main").on("singletap", "li", function() {
      if ($(this).data("function")) {
        var func = window[$(this).data("function")];
        func(this);
      }
  });

  $('#preferences_button').on('singletap', function() {
    $.UIGoToArticle('#preferences');
  });

  $('#all_championships_switch').on('singletap swipeleft swiperight', function() {
    if (this.classList.contains('on')) {
      localStorage.setItem('all_championships', 'Y');
      all_championships = true;
    } else {
      localStorage.setItem('all_championships', 'N');
      all_championships = false;
    }
    $('#goto_select_championships').toggle();
    updateServer();
    updateMainPage();
    //buildMainPage();
  });

  divisions = localStorage.getItem('divisions') ? localStorage.getItem('divisions').split(',') : [0];
  sports    = localStorage.getItem('sports')    ? localStorage.getItem('sports').split(',')    : [];

  if (localStorage.getItem('all_championships') == 'Y' || divisions.length == 0 || sports.length == 0) {
    all_championships = true;
    localStorage.setItem('all_championships', 'Y');
    $('#all_championships_switch').addClass('on');
    $('#goto_select_championships').hide();
  }

  for (var i=0; i < SPORTS.length; i++) {
    $('<li class="' + SPORTS[i]['code'] + '" data-select-value="' + SPORTS[i]['code'] + '"><h3>' + SPORTS[i]['description'] + '</h3></li>').appendTo('#select_sports');;
  }

  $('.multi_select li').on('singletap swipeleft swiperight', function() {
    $(this).toggleClass('selected');
    if ($(this).hasClass('selected')) {
      setValue($(this).parent().data("name"), $(this).data("select-value"));
    } else {
      removeValue($(this).parent().data("name"), $(this).data("select-value"));
    }
    updateServer();
    updateMainPage();
    //buildMainPage();
  });


  sportTemplate       = $.template($('#sportTemplate').text());
  manualSportTemplate = $.template($('#manualSportTemplate').text());
  manualLinkTemplate  = $.template($('#manualLinkTemplate').text(), 'link');
  mainTemplate        = $.template($('#mainTemplate').text());
  headingTemplate     = $.template($('#headingTemplate').text());
  articleTemplate     = $.template($('#articleTemplate').text(), "link");


  for (var i=0; i < divisions.length; i++) {
    $('#select_divisions .' + divisions[i]).addClass('selected');
  }
  for (var i=0; i < sports.length; i++) {
    $('#select_sports .' + sports[i]).addClass('selected');
  }

  updateMainPage();
  //buildMainPage();

});


// Push Notification Changes

var pushNotification = null;
function onDeviceReady() {
  try
  {
    pushNotification = window.plugins.pushNotification;
    $("#app-status-ul").append('<li>registering ' + device.platform + '</li>');
    if (device.platform == 'android' || device.platform == 'Android' ||
        device.platform == 'amazon-fireos' ) {
    /*
      $('#main_nav').append("<a class='button align-flush' id='show_preferences' href='#'>Preferences</a>");
      $('#show_preferences').click(function() {
        $.UIGoToArticle('#preferences');
      });
     */

      pushNotification.register(successHandler, errorHandler, {"senderID":"500629174868","ecb":"onNotification"});		// required!
    } else {
      pushNotification.register(tokenHandler, errorHandler, {"badge":"true","sound":"true","alert":"true","ecb":"onNotificationAPN"});	// required!
    }
  }
  catch(err)
  {
    txt="There was an error on this page.\n\n";
    txt+="Error description: " + err.message + "\n\n";
    alert(txt);
  }
}

// handle APNS notifications for iOS
function onNotificationAPN(e) {

  if (!hasSelected(e.sport_code, e.division)) {
    //$("#app-status-ul").append('<li>push-notification: ' + e.division + e.sport_code + ' does not apply.</li>');
    return;
  }

  if (e.alert) {
    //$("#app-status-ul").append('<li>push-notification: ' + e.alert + '</li>');
    navigator.notification.alert(e.alert, null, 'Notification');
    //alert('Other: ' + e.other);
    //alert('Sport Code: ' + e.sport_code);
    //alert('Division: '   + e.division);
  }

  //alert(e.badge);
  if (e.badge) {
    //alert(e.badge);
    pushNotification.setApplicationIconBadgeNumber(parseInt(e.badge));
  }

  if (e.sound) {
    var snd = new Media(e.sound);
    snd.play();
  }

}

function onResume() {
  pushNotification.setApplicationIconBadgeNumber(0);
  getPending();
}

function getPending() {
  pushNotification.getPendingNotifications(function(notifications) {
    alert(JSON.stringify(['getPendingNotifications', notifications]));
  });
}

// handle GCM notifications for Android
function onNotification(e) {
  //$("#app-status-ul").append('<li>EVENT -> RECEIVED:' + e.event + '</li>');

  switch( e.event )
  {
    case 'registered':
      if ( e.regid.length > 0 )
    {
      setDeviceToken(e.regid);
      setDeviceType('Android');
      updateServer();

      //$("#app-status-ul").append('<li>REGISTERED -> REGID:' + e.regid + "</li>");
      // Your GCM push server needs to know the regID before it can push to this device
      // here is where you might want to send it the regID for later use.
      console.log("regID = " + e.regid);
    }
    break;

    case 'message':
      // if this flag is set, this notification happened while we were in the foreground.
      // you might want to play a sound to get the user's attention, throw up a dialog, etc.
      if (e.foreground) {
      //$("#app-status-ul").append('<li>--INLINE NOTIFICATION--' + '</li>');

      // on Android soundname is outside the payload.
      // On Amazon FireOS all custom attributes are contained within payload
      //var soundfile = e.soundname || e.payload.sound;
      // if the notification contains a soundname, play it.
      //var my_media = new Media("/android_asset/www/"+ soundfile);
      //my_media.play();
        navigator.notification.alert(e.payload.message, null, 'Notification');

      } else {	// otherwise we were launched because the user touched a notification in the notification tray.
        if (e.coldstart)
          $("#app-status-ul").append('<li>--COLDSTART NOTIFICATION--' + '</li>');
        else
          $("#app-status-ul").append('<li>--BACKGROUND NOTIFICATION--' + '</li>');
      }

      $("#app-status-ul").append('<li>MESSAGE -> MSG: ' + e.payload.message + '</li>');
      //android only
      $("#app-status-ul").append('<li>MESSAGE -> MSGCNT: ' + e.payload.msgcnt + '</li>');
      //amazon-fireos only
      $("#app-status-ul").append('<li>MESSAGE -> TIMESTAMP: ' + e.payload.timeStamp + '</li>');
      break;

    case 'error':
        $("#app-status-ul").append('<li>ERROR -> MSG:' + e.msg + '</li>');
      break;

    default:
        $("#app-status-ul").append('<li>EVENT -> Unknown, an event was received and we do not know what it is</li>');
      break;
  }
}

function tokenHandler (result) {
  setDeviceToken(result);
  setDeviceType('IOS');
  //$("#app-status-ul").append('<li>token: '+ result +'</li>');
  // Your iOS push server needs to know the token before it can push to this device
  // here is where you might want to send it the token for later use.
  updateServer();
}

function successHandler (result) {
  $("#app-status-ul").append('<li>success:'+ result +'</li>');
}

function errorHandler (error) {
  $("#app-status-ul").append('<li>error:'+ error +'</li>');
}
